package tiny;

import java.util.Stack;

class CodeGen {
	SymbolTable st; // nvel atual!
	int temp;
	int label;
	StringBuilder out;
	Stack<Integer> exits;
	
	CodeGen(int temp) {
		label = 0;
		this.temp = temp;
		out = new StringBuilder();
		exits = new Stack<Integer>();
	}
	
	void label(int lab) {
		out.append("label" + lab + ":\n");
	}

	void emit(String s) {
		out.append(s + "\n");
	}

	void emitJmp(int label) {
		emit("JMP", "label" + label);
	}
	
	void emit(String op, String arg1, String arg2, String arg3) {
		out.append("  " + op + " " + arg1 + " " + arg2 + " " + arg3 + "\n");
	}

	void emit(String op, String arg1, String arg2) {
		out.append("  " + op + " " + arg1 + " " + arg2 + "\n");
	}

	void emit(String op, String arg1) {
		out.append("  " + op + " " + arg1 + "\n");
	}			
}
