package tiny;

import java.util.Map;

class TypeCheck extends Visitor {
	Map<String, Integer> arities;
	
	void visit(FuncProgram fp) {
		arities = fp.arities;
		super.visit(fp);
	}
	
	void visit(IfCommand tif) {
		tif.cond.accept(this);
		if(tif.cond.type!=Expression.BOOL)
			throw new RuntimeException("condio do if no  exp. booleana");
		for(Command cmd : tif.cmd_then)
			cmd.accept(this);
		if(tif.cmd_else != null)
			for(Command cmd : tif.cmd_else)
				cmd.accept(this);
	}
	
	void visit(RepeatCommand tr) {
		for(Command cmd : tr.cmd_body)
			cmd.accept(this);
		tr.cond.accept(this);
		if(tr.cond.type!=Expression.BOOL)
			throw new RuntimeException("condio do repeat no  exp. booleana");
	}
	
	void visit(WriteCommand tw) {
		tw.exp.accept(this);
		if(tw.exp.type!=Expression.INT)
			throw new RuntimeException("expresso do write no  numrica");		
	}
	
	void visit(AssignCommand ta) {
		ta.rval.accept(this);
		if(ta.rval.type!=Expression.INT)
			throw new RuntimeException("lado direito da atrib. no  exp. numrica");		
	}
	
	void visit(NumeralExpression tn) {
		tn.type = Expression.INT;
	}
	
	void visit(VarExpression tv) {
		tv.type = Expression.INT;
	}

	void visit(UnmExpression tu) {
		tu.exp.accept(this);
		if(tu.exp.type != Expression.INT)
			throw new RuntimeException("tipos invlidos no menos");
		tu.type = Expression.INT;
	}
	
	void visitRel(BinopExpression tr) {
		tr.left.accept(this);
		tr.right.accept(this);
		if(tr.left.type != Expression.INT
				|| tr.right.type != Expression.INT)
			throw new RuntimeException("tipos invlidos na comparao");
		tr.type = Expression.BOOL;
	}
	
	void visit(LtExpression tr) {
		visitRel(tr);
	}

	void visit(EqExpression tr) {
		visitRel(tr);
	}

	void visitArith(BinopExpression tr) {
		tr.left.accept(this);
		tr.right.accept(this);
		if(tr.left.type != Expression.INT
				|| tr.right.type != Expression.INT)
			throw new RuntimeException("tipos invlidos na op. aritmtica");
		tr.type = Expression.INT;
	}

	void visit(AddExpression tr) {
		visitArith(tr);
	}

	void visit(SubExpression tr) {
		visitArith(tr);
	}

	void visit(MulExpression tr) {
		visitArith(tr);
	}
	
	void visit(DivExpression tr) {
		visitArith(tr);
	}

	void visit(NotExpression tu) {
		tu.exp.accept(this);
		if(tu.exp.type != Expression.BOOL)
			throw new RuntimeException("tipos invlidos no not");
		tu.type = Expression.BOOL;
	}

	void visitLog(BinopExpression tr) {
		tr.left.accept(this);
		tr.right.accept(this);
		if(tr.left.type != Expression.BOOL
				|| tr.right.type != Expression.BOOL)
			throw new RuntimeException("tipos invlidos na op. lgica");
		tr.type = Expression.BOOL;
	}

	void visit(AndExpression tr) {
		visitLog(tr);
	}

	void visit(OrExpression tr) {
		visitLog(tr);
	}

	void visit(FuncallCommand fe) {
		if(!arities.get(fe.name).equals(fe.args.size()))
			throw new RuntimeException("nmero de argumentos invlido");
		for(Expression exp : fe.args) {
			exp.accept(this);
			if(exp.type != Expression.INT)
				throw new RuntimeException("tipo invlid em argumento");
		}
	}
	
	void visit(FuncallExpression fe) {
		if(!arities.get(fe.name).equals(fe.args.size()))
			throw new RuntimeException("nmero de argumentos invlido");
		for(Expression exp : fe.args) {
			exp.accept(this);
			if(exp.type != Expression.INT)
				throw new RuntimeException("tipo invlid em argumento");
		}
		fe.type = Expression.INT;
	}
}